Index: /trunk/src/world_entities/camera.cc
===================================================================
--- /trunk/src/world_entities/camera.cc	(revision 6806)
+++ /trunk/src/world_entities/camera.cc	(revision 6807)
@@ -111,37 +111,16 @@
     case VIEW_NORMAL:
       this->toFovy = 60.0;
-      /*      this->setParentSoft("TrackNode");
-            this->target->setParentSoft("TrackNode"); */
       this->setRelCoorSoft(-10, 5, 0);
       this->target->setRelCoorSoft(0,0,0);
       break;
     case VIEW_BEHIND:
-      //      this->toFovy = 120.0;
-      //      this->setRelCoorSoft(Vector(3.5, 0, 0));
-      //    this->target->setRelCoorSoft(Vector(10,0,0));
-
-      //       if (!strcmp(this->target->getParent()->getName(), "Player"))
-      //         this->target->setParentSoft("TrackNode");
-      //       else
-      //         this->target->setParentSoft("Player");
-      //       this->getParent()->debugNode(0);
-
-      //      this->setParent("main-Turret");
-      //      this->setParentMode(PNODE_ALL);
-      //      this->target->setParentSoft("Player");
-
       break;
     case VIEW_FRONT:
       this->toFovy = 120.0;
-      /*       this->setParentSoft("Player");
-             this->target->setParentSoft("Player");*/
       this->setRelCoorSoft(4, 0, 0, 5);
       this->target->setRelCoorSoft(Vector(10,0,0), 5);
-      //      this->target->setRelDirSoft(Quaternion(M_PI/4.0, Vector(0,1,0)));
       break;
     case VIEW_LEFT:
       this->toFovy = 90;
-      /*      this->setParentSoft("TrackNode");
-            this->target->setParentSoft("TrackNode");*/
       this->setRelCoorSoft(0, 1, -10, .5);
       this->target->setRelCoorSoft(0,0,0);
@@ -149,6 +128,4 @@
     case VIEW_RIGHT:
       this->toFovy = 90;
-      /*      this->setParentSoft("TrackNode");
-            this->target->setParentSoft("TrackNode");*/
       this->setRelCoorSoft(Vector(0, 1, 10));
       this->target->setRelCoorSoft(0,0,0);
@@ -156,6 +133,4 @@
     case VIEW_TOP:
       this->toFovy= 120;
-      /*      this->setParentSoft("TrackNode");
-            this->target->setParentSoft("TrackNode");*/
       this->setRelCoorSoft(Vector(30, 50, 0));
       this->target->setRelCoorSoft(35,0,0);
Index: /trunk/src/world_entities/space_ships/hover.cc
===================================================================
--- /trunk/src/world_entities/space_ships/hover.cc	(revision 6806)
+++ /trunk/src/world_entities/space_ships/hover.cc	(revision 6807)
@@ -99,18 +99,15 @@
   this->setClassID(CL_HOVER, "Hover");
 
-  PRINTF(4)("HOVER INIT\n");
-
-  this->loadModel("models/ships/hover_#.obj", 1.0);
-
-  EventHandler::getInstance()->grabEvents(true);
+  this->loadModel("models/ships/hoverglider_wing.obj", 1.0f, 3);
+  this->loadModel("models/ships/hoverglider_rotor.obj", 1.0f, 4);
+  this->loadModel("models/ships/rotor.obj", .45f, 5);
 
   bForward = bBackward = bLeft = bRight = bAscend = bDescend = false;
-  xMouse = yMouse = 0;
-  mouseSensitivity = 0.05;
-  controlVelocityX = 100;
-  controlVelocityY = 100;
+  mouseSensitivity = 0.005;
 
   this->rotorSpeed = 1000.0f;
   this->rotorCycle = 0.0f;
+  this->cameraLook = 0.0f;
+  this->rotation = 0.0f;
 
   // camera - issue
@@ -138,7 +135,4 @@
   dynamic_cast<Element2D*>(this->getWeaponManager()->getFixedTarget())->setVisibility( false);
 
-  this->loadModel("models/ships/hoverglider_wing.obj", 1.0f, 3);
-  this->loadModel("models/ships/hoverglider_rotor.obj", 1.0f, 4);
-  this->loadModel("models/ships/rotor.obj", .45f, 5);
 
   //add events to the eventlist
@@ -177,5 +171,7 @@
   this->getWeaponManager()->setSlotDirection(4, Quaternion(24/180 * M_PI, Vector(1,0,0)));
 
-  this->getWeaponManager()->getFixedTarget()->setParent(&(this->cameraNode));
+  this->cameraNode.setRelCoor(1,5,0);
+  this->getWeaponManager()->getFixedTarget()->setParent(&this->cameraNode);
+  this->getWeaponManager()->getFixedTarget()->setRelCoor(1000,0,0);
 }
 
@@ -192,6 +188,6 @@
 {
   State::getCamera()->setParentSoft(&this->cameraNode);
-  State::getCameraTarget()->setParentSoft(this->getWeaponManager()->getFixedTarget());
-
+  State::getCamera()->setRelCoorSoft(-10, 0,0);
+  State::getCameraTarget()->setParentSoft(&this->cameraNode);
 }
 
@@ -234,6 +230,5 @@
  */
 void Hover::collidesWith(WorldEntity* entity, const Vector& location)
-{
-}
+{}
 
 
@@ -246,12 +241,4 @@
 {
   Playable::tick(dt);
-
-  if( xMouse != 0 || yMouse != 0)
-  {
-    if (xMouse > controlVelocityX) xMouse = controlVelocityX;
-    else if (xMouse < -controlVelocityX) xMouse = -controlVelocityX;
-    if (yMouse > controlVelocityY) yMouse = controlVelocityY;
-    else if (yMouse < -controlVelocityY) yMouse = -controlVelocityY;
-  }
 
   // spaceship controlled movement
@@ -262,7 +249,9 @@
 
   // this is the air friction (necessary for a smooth control)
-  if(velocity.len() != 0) velocity -= velocity*0.1;
-    this->shiftCoor (move);
-
+  if(velocity.len() != 0)
+    velocity -= velocity*0.1;
+  this->shiftCoor (move);
+
+  this->rotation = 0.0f;
 }
 
@@ -276,14 +265,15 @@
   float rotVal = .3;
 
-  if( this->bForward )  {
+  if( this->bForward ) {
     accel += Vector(rotVal, 0, 0);
   }
 
   if( this->bBackward ) {
-      accel -= Vector(rotVal,0,0);
+    accel -= Vector(rotVal,0,0);
   }
   if( this->bLeft) {
     accel -= Vector(0,0,rotVal);
   }
+
   if( this->bRight) {
     accel += Vector(0,0,rotVal);
@@ -293,6 +283,7 @@
     accel += Vector(0,rotVal,0);
   }
-  if (this->bDescend )
-    accel -= Vector(0,rotVal,0);
+  if (this->bDescend ) {
+       accel -= Vector(0,rotVal,0);
+  }
 
   velocity += accel * 3.0;
@@ -300,9 +291,9 @@
   this->setRelDirSoft(this->direction * Quaternion(-accel.x, Vector(0,0,1)) * Quaternion(accel.z, Vector(1,0,0)), 5);
 
-  this->wingNodeLeft.setRelDirSoft(Quaternion(accel.z, Vector(1,0,0)), 10);
-  this->rotorNodeLeft.setRelDirSoft(Quaternion(-2.0*accel.x, Vector(0,0,1)), 10);
-
-  this->wingNodeRight.setRelDirSoft(Quaternion(accel.z, Vector(1,0,0)), 10);
-  this->rotorNodeRight.setRelDirSoft(Quaternion(-2.0*accel.x, Vector(0,0,1)), 10);
+  this->wingNodeLeft.setRelDirSoft(Quaternion(accel.z+this->rotation, Vector(1,0,0)), 10);
+  this->rotorNodeLeft.setRelDirSoft(Quaternion(-2.0*accel.x+this->rotation, Vector(0,0,1)), 10);
+
+  this->wingNodeRight.setRelDirSoft(Quaternion(accel.z+this->rotation, Vector(1,0,0)), 10);
+  this->rotorNodeRight.setRelDirSoft(Quaternion(-2.0*accel.x-this->rotation, Vector(0,0,1)), 10);
 }
 
@@ -381,24 +372,19 @@
   else if( event.type == EV_MOUSE_MOTION)
   {
-    this->xMouse = event.xRel*mouseSensitivity;
-    this->yMouse = event.yRel*mouseSensitivity;
+    float xMouse, yMouse;
+    xMouse = event.xRel*mouseSensitivity;
+    yMouse = event.yRel*mouseSensitivity;
 
     // rotate the Player around the y-axis
-    this->direction *= Quaternion(-M_PI/4*xMouse*mouseSensitivity, Vector(0,1,0));
-
+    this->direction *= Quaternion(-M_PI/4.0*xMouse, Vector(0,1,0));
+    this->rotation += xMouse;
+
+    this->cameraLook += yMouse;
     // rotate the Camera around the z-axis
-    Quaternion yDir = Quaternion(-M_PI/4*yMouse*mouseSensitivity, Vector(0,0,1));
-    if ((this->cameraNode.getAbsDirY()).y < 0.5)
-    {
-      if((this->cameraNode.getAbsDirX()).y > 0)
-      {
-        if(yMouse > 0) this->cameraNode.shiftDir(yDir);
-      }
-      else
-      {
-        if(yMouse < 0) this->cameraNode.shiftDir(yDir);
-      }
-    }
-    else this->cameraNode.shiftDir(yDir);
-  }
-}
+    if (cameraLook > M_PI_4)
+      cameraLook = M_PI_4;
+    else if (cameraLook < -M_PI_2)
+      cameraLook = -M_PI_2;
+    this->cameraNode.setRelDirSoft(Quaternion(-cameraLook, Vector(0,0,1)),5);
+  }
+}
Index: /trunk/src/world_entities/space_ships/hover.h
===================================================================
--- /trunk/src/world_entities/space_ships/hover.h	(revision 6806)
+++ /trunk/src/world_entities/space_ships/hover.h	(revision 6807)
@@ -45,11 +45,6 @@
     bool                  bDescend;           //!< descend button presses.
 
-    float                 xMouse;             //!< mouse moved in x-Direction
-    float                 yMouse;             //!< mouse moved in y-Direction
     int                   yInvert;
     float                 mouseSensitivity;   //!< the mouse sensitivity
-    int                   controlVelocityX;
-    int                   controlVelocityY;
-    //float                 cycle;              //!< hovercycle
 
     PNode                 wingNodeLeft;
@@ -59,4 +54,6 @@
 
     PNode                 cameraNode;
+    float                 cameraLook;
+    float                 rotation;
 
     Vector                velocity;           //!< the velocity of the Hover.
Index: /trunk/src/world_entities/space_ships/space_ship.cc
===================================================================
--- /trunk/src/world_entities/space_ships/space_ship.cc	(revision 6806)
+++ /trunk/src/world_entities/space_ships/space_ship.cc	(revision 6807)
@@ -56,11 +56,4 @@
 CREATE_FACTORY(SpaceShip, CL_SPACE_SHIP);
 
-/**
- *  creates the controlable Spaceship
- */
-SpaceShip::SpaceShip()
-{
-  this->init();
-}
 
 /**
Index: /trunk/src/world_entities/space_ships/space_ship.h
===================================================================
--- /trunk/src/world_entities/space_ships/space_ship.h	(revision 6806)
+++ /trunk/src/world_entities/space_ships/space_ship.h	(revision 6807)
@@ -21,8 +21,6 @@
 
   public:
-
-    SpaceShip();
     SpaceShip(const char* fileName);
-    SpaceShip(const TiXmlElement* root);
+    SpaceShip(const TiXmlElement* root = NULL);
     virtual ~SpaceShip();
 
Index: /trunk/src/world_entities/weapons/crosshair.cc
===================================================================
--- /trunk/src/world_entities/weapons/crosshair.cc	(revision 6806)
+++ /trunk/src/world_entities/weapons/crosshair.cc	(revision 6807)
@@ -135,5 +135,5 @@
   this->shiftDir2D(dt * rotationSpeed);
 
-
+/*
   float z = 0.0f;
   glReadPixels ((int)this->getAbsCoor2D().x,
@@ -155,5 +155,5 @@
                &objX,
                &objY,
-               &objZ );
+               &objZ );*/
 
   //this->setAbsCoor(objX, objY, objZ);
@@ -181,4 +181,3 @@
   glEnd();
   glPopMatrix();
-
 }
Index: /trunk/src/world_entities/weapons/weapon_manager.cc
===================================================================
--- /trunk/src/world_entities/weapons/weapon_manager.cc	(revision 6806)
+++ /trunk/src/world_entities/weapons/weapon_manager.cc	(revision 6807)
@@ -104,5 +104,5 @@
   // CROSSHAIR INITIALISATION
   this->crosshair = new Crosshair();
-
+  //this->crosshair->setRelCoor(1000,0,0);
   this->crossHairSizeAnim = new tAnimation<Crosshair>(this->crosshair, &Crosshair::setSize);
   this->crossHairSizeAnim->setInfinity(ANIM_INF_REWIND);